<?xml version="1.0" encoding="UTF-8"?>
<!--
Copyright (c) 2006, 2022 IBM Corp. and others

This program and the accompanying materials are made available under
the terms of the Eclipse Public License 2.0 which accompanies this
distribution and is available at https://www.eclipse.org/legal/epl-2.0/
or the Apache License, Version 2.0 which accompanies this distribution and
is available at https://www.apache.org/licenses/LICENSE-2.0.

This Source Code may also be made available under the following
Secondary Licenses when the conditions for such availability set
forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
General Public License, version 2 with the GNU Classpath
Exception [1] and GNU General Public License, version 2 with the
OpenJDK Assembly Exception [2].

[1] https://www.gnu.org/software/classpath/license.html
[2] https://openjdk.org/legal/assembly-exception.html

SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
-->
<vmconstantpool>
	<classref name="java/lang/ArrayStoreException"/>
	<classref name="java/lang/ClassCastException"/>
	<classref name="java/lang/IllegalMonitorStateException"/>
	<classref name="java/lang/IndexOutOfBoundsException"/>
	<classref name="java/lang/NegativeArraySizeException"/>
	<classref name="java/lang/NullPointerException"/>
	<classref name="java/lang/VirtualMachineError"/>
	<classref name="java/lang/InstantiationError"/>
	<classref name="java/lang/UnsatisfiedLinkError"/>
	<classref name="java/lang/InternalError"/>
	<classref name="java/lang/OutOfMemoryError"/>
	<classref name="java/lang/StackOverflowError"/>
	<classref name="java/lang/UnsupportedClassVersionError"/>
	<classref name="java/lang/AbstractMethodError"/>
	<classref name="java/lang/IncompatibleClassChangeError"/>
	<classref name="java/lang/IllegalAccessError"/>
	<classref name="java/lang/NoSuchMethodError"/>
	<classref name="java/lang/CloneNotSupportedException"/>
	<classref name="java/lang/InstantiationException"/>
	<classref name="java/lang/NoSuchFieldError"/>
	<classref name="java/lang/NoClassDefFoundError"/>
	<classref name="java/lang/ArrayIndexOutOfBoundsException"/>
	<classref name="java/lang/Object"/>
	<classref name="java/lang/String"/>
	<classref name="java/lang/String$StringCompressionFlag"/>
	<classref name="java/lang/Class"/>
	<classref name="java/lang/IllegalThreadStateException"/>
	<classref name="java/lang/Thread"/>
	<classref name="java/lang/Thread$FieldHolder" versions="19-"/>
	<classref name="java/lang/BaseVirtualThread" versions="19-"/>
	<classref name="java/lang/VirtualThread" versions="19-"/>
	<classref name="java/lang/ArithmeticException"/>
	<classref name="java/lang/ThreadGroup"/>
	<classref name="java/lang/InterruptedException"/>
	<classref name="java/lang/ClassNotFoundException"/>
	<classref name="java/lang/Throwable" flags="interp_hotCodeReplacement"/>
	<classref name="com/ibm/oti/vm/ReflectObjectInvalidException" flags="opt_reflect"/>
	<classref name="java/lang/StringIndexOutOfBoundsException"/>
	<classref name="java/lang/ThreadDeath"/>
	<classref name="java/lang/IllegalAccessException"/>
	<classref name="java/lang/IllegalArgumentException"/>
	<classref name="java/lang/LayerInstantiationException" flags="opt_module" versions="9-"/>
	<classref name="java/lang/reflect/Method" flags="opt_reflect"/>
	<classref name="java/lang/reflect/Field" flags="opt_reflect"/>
	<classref name="java/lang/reflect/RecordComponent" flags="opt_reflect" versions="14-"/>
	<classref name="java/lang/LinkageError"/>
	<classref name="java/lang/Byte" flags="opt_reflect"/>
	<classref name="java/lang/Short" flags="opt_reflect"/>
	<classref name="java/lang/Integer" flags="opt_reflect"/>
	<classref name="java/lang/Long" flags="opt_reflect"/>
	<classref name="java/lang/Float" flags="opt_reflect"/>
	<classref name="java/lang/Double" flags="opt_reflect"/>
	<classref name="java/lang/Boolean" flags="opt_reflect"/>
	<classref name="java/lang/Character" flags="opt_reflect"/>
	<classref name="java/lang/Void" flags="opt_reflect"/>
	<classref name="java/lang/ClassLoader"/>
	<classref name="java/lang/NoSuchFieldException" flags="opt_reflect"/>
	<classref name="java/lang/NoSuchMethodException" flags="opt_reflect"/>
	<classref name="java/lang/reflect/Constructor" flags="opt_reflect"/>
	<classref name="java/lang/ClassCircularityError"/>
	<classref name="java/lang/VerifyError"/>
	<classref name="java/lang/ClassFormatError"/>
	<classref name="java/lang/StackTraceElement"/>
	<classref name="java/lang/StackWalker$StackFrameImpl"/>
	<classref name="java/lang/InternalConstantPool"/>
	<classref name="java/lang/ExceptionInInitializerError"/>
	<classref name="java/io/UTFDataFormatException"/>
	<classref name="java/lang/reflect/InvocationTargetException" flags="opt_reflect"/>
	<classref name="java/lang/J9VMInternals"/>
	<classref name="com/ibm/oti/lang/ThreadDeath"/>
	<classref name="java/lang/ref/Reference"/>
	<classref name="java/lang/ref/SoftReference"/>
	<classref name="java/util/concurrent/locks/AbstractOwnableSynchronizer"/>
	<classref name="java/lang/invoke/PrimitiveHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/NativeMethodHandle" flags="opt_panama"/>
	<classref name="java/lang/invoke/ReceiverBoundHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConvertHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/CollectHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/DynamicInvokerHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/FilterReturnHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/FoldHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/FilterArgumentsHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/GuardWithTestHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/VarargsCollectorHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/InvokeExactHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/SpreadHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/VolatileCallSite" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/MutableCallSite" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/PassThroughHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/InsertHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/PermuteHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConstantObjectHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConstantIntHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConstantFloatHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConstantLongHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/ConstantDoubleHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/InvokeGenericHandle" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/DefaultMethodConflictException" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/MethodHandleCache" flags="opt_methodHandle"/>
	<classref name="java/lang/SecurityException"/>
	<classref name="java/lang/J9VMInternals$ClassInitializationLock"/>
	<classref name="java/lang/invoke/ThunkTuple" flags="opt_methodHandle"/>
	<classref name="com/ibm/oti/util/WeakReferenceNode"/>
	<classref name="com/ibm/oti/vm/VM"/>
	<classref name="java/lang/System"/>
	<classref name="java/lang/Module" flags="opt_module" versions="9-"/>
	<classref name="java/lang/invoke/VarHandleInvokeHandle" versions="9-" flags="opt_methodHandle"/>
	<classref name="java/lang/invoke/FieldVarHandle" versions="9-" flags="opt_methodHandle"/>

	<!-- Common class references shared between OpenJ9 and OpenJDK MethodHandles. -->
	<classref name="java/lang/invoke/MethodType" flags="opt_methodHandleCommon"/>
	<classref name="java/lang/invoke/MethodHandle" flags="opt_methodHandleCommon"/>
	<classref name="java/lang/invoke/WrongMethodTypeException" flags="opt_methodHandleCommon"/>
	<classref name="java/lang/invoke/MethodTypeHelper" flags="opt_methodHandleCommon"/>
	<classref name="java/lang/invoke/MethodHandleResolver" flags="opt_methodHandleCommon"/>
	<classref name="java/lang/invoke/VarHandle" versions="9-" flags="opt_methodHandleCommon"/>

	<!-- Class references needed to support OpenJDK MethodHandles. -->
	<classref name="java/lang/invoke/MemberName" flags="opt_openjdkMethodhandle"/>
	<classref name="java/lang/invoke/MethodTypeForm" flags="opt_openjdkMethodhandle"/>
	<classref name="java/lang/invoke/LambdaForm" flags="opt_openjdkMethodhandle"/>

	<classref name="jdk/internal/loader/NativeLibraries" versions="15-"/>
	<classref name="jdk/internal/loader/NativeLibraries$NativeLibraryImpl" versions="15-"/>

	<classref name="java/lang/invoke/MethodHandleNatives" flags="opt_openjdkMethodhandle" versions="18-"/>

	<classref name="jdk/internal/vm/Continuation" versions="19-"/>

	<classref name="org/eclipse/openj9/criu/JVMCheckpointException" flags="opt_criuSupport"/>
	<classref name="org/eclipse/openj9/criu/JVMRestoreException" flags="opt_criuSupport"/>

	<!-- Class references needed to support Foreign Linker API. -->
	<classref name="openj9/internal/foreign/abi/InternalDowncallHandler" flags="opt_openjdkFfi" versions="16-"/>
	<classref name="openj9/internal/foreign/abi/InternalUpcallHandler" flags="opt_openjdkFfi" versions="16-"/>
	<classref name="openj9/internal/foreign/abi/UpcallMHMetaData" flags="opt_openjdkFfi" versions="16-"/>

	<classref name="jdk/incubator/foreign/MemoryAddress" flags="opt_openjdkFfi" versions="16-18"/>
	<classref name="jdk/lang/foreign/MemoryAddress" flags="opt_openjdkFfi" versions="19-"/>
	<classref name="jdk/incubator/foreign/MemorySegment" flags="opt_openjdkFfi" versions="16-18"/>
	<classref name="jdk/lang/foreign/MemorySegment" flags="opt_openjdkFfi" versions="19-"/>
	<classref name="jdk/internal/foreign/MemoryAddressImpl" flags="opt_openjdkFfi" versions="16-"/>
	<classref name="jdk/internal/foreign/AbstractMemorySegmentImpl" flags="opt_openjdkFfi" versions="16-"/>
	<classref name="jdk/internal/foreign/NativeMemorySegmentImpl" flags="opt_openjdkFfi" versions="16-"/>
	<classref name="jdk/internal/foreign/SharedScope" flags="opt_openjdkFfi" versions="16-18"/>
	<classref name="jdk/internal/foreign/SharedSession" flags="opt_openjdkFfi" versions="19-"/>

<!--
	NOTE: the resolution code in jclcinit.c only looks at the J9ROMClassRef->runtimeFlags to determine
	whether or not to attempt the class load.  The flags sepcified on the fields are ignored.
	The field flags are only documentation to help map which feature (as expressed on the class) requires
	the particular field.

	This is a limitation of the tool as it would otherwise need to encode the class multiple times - once
	for each combination of field flags.
-->
	<fieldref class="java/lang/ClassLoader" name="parent" signature="Ljava/lang/ClassLoader;"/>
	<fieldref class="java/lang/ClassLoader" name="vmRef" signature="J" cast="struct J9ClassLoader *"/>
	<fieldref class="java/lang/ClassLoader" name="isParallelCapable" signature="Z"/>
	<fieldref class="java/lang/ClassLoader" name="unnamedModule" signature="Ljava/lang/Module;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/ClassLoader" name="classLoaderName" signature="Ljava/lang/String;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/Class" name="reflectCache" signature="Ljava/lang/Class$ReflectCache;"/>
	<fieldref class="java/lang/Class" name="classLoader" signature="Ljava/lang/ClassLoader;"/>
	<fieldref class="java/lang/Class" name="vmRef" signature="J" cast="struct J9Class *"/>
	<fieldref class="java/lang/Class" name="initializationLock" signature="Ljava/lang/J9VMInternals$ClassInitializationLock;"/>
	<fieldref class="java/lang/Class" name="protectionDomain" signature="Ljava/security/ProtectionDomain;"/>
	<fieldref class="java/lang/Class" name="classNameString" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/Class" name="fileNameString" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/Class" name="annotationCache" signature="Ljava/lang/Class$AnnotationCache;"/>
	<fieldref class="java/lang/Class" name="module" signature="Ljava/lang/Module;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/Class" name="methodHandleCache" signature="Ljava/lang/Object;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/Class" name="classData" signature="Ljava/lang/Object;" versions="15-"/>

	<staticfieldref class="java/lang/String" name="compressionFlag" signature="Ljava/lang/String$StringCompressionFlag;"/>
	<fieldref class="java/lang/String" name="value" signature="[B" versions="9-">
		<fieldalias name="value" signature="[C" versions="8"/>
	</fieldref>
	<fieldref class="java/lang/String" name="count" signature="I" versions="8"/>
	<fieldref class="java/lang/String" name="hash" signature="I"/>
	<fieldref class="java/lang/String" name="coder" signature="B" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="moduleName" signature="Ljava/lang/String;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="moduleVersion" signature="Ljava/lang/String;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="declaringClass" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/StackTraceElement" name="classLoaderName" signature="Ljava/lang/String;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="includeClassLoaderName" signature="Z" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="includeModuleVersion" signature="Z" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/StackTraceElement" name="methodName" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/StackTraceElement" name="fileName" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/StackTraceElement" name="lineNumber" signature="I"/>
	<fieldref class="java/lang/StackTraceElement" name="source" signature="Ljava/lang/Object;"/>

	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="declaringClass" signature="Ljava/lang/Class;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="callerSensitive" signature="Z" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="fileName" signature="Ljava/lang/String;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="bytecodeIndex" signature="I" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="className" signature="Ljava/lang/String;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="classLoaderName" signature="Ljava/lang/String;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="lineNumber" signature="I" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="methodName" signature="Ljava/lang/String;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="methodSignature" signature="Ljava/lang/String;" versions="9-"/>
	<fieldref class="java/lang/StackWalker$StackFrameImpl" name="frameModule" signature="Ljava/lang/Module;" versions="9-"/>

	<!-- Common field references shared between OpenJ9 and OpenJDK Thread. -->
	<fieldref class="java/lang/Thread" name="contextClassLoader" signature="Ljava/lang/ClassLoader;"/>
	<fieldref class="java/lang/Thread" name="inheritedAccessControlContext" signature="Ljava/security/AccessControlContext;"/>
	<fieldref class="java/lang/Thread" name="name" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/Thread" name="parkBlocker" signature="Ljava/lang/Object;"/>
	<fieldref class="java/lang/Thread" name="tid" signature="J"/>
	<fieldref class="java/lang/Thread" name="threadRef" signature="J" cast="struct J9VMThread *" versions="8-18">
		<fieldalias name="eetop" signature="J" cast="struct J9VMThread *" versions="19-"/>
	</fieldref>
	<fieldref class="java/lang/Thread" name="deadInterrupt" signature="Z" versions="14-18">
		<fieldalias name="interrupted" signature="Z" versions="19-"/>
	</fieldref>
	<fieldref class="java/lang/Thread" name="lock" signature="Ljava/lang/Object;" versions="8-18">
		<fieldalias name="interruptLock" signature="Ljava/lang/Object;" versions="19-"/>
	</fieldref>
	<fieldref class="java/lang/Thread" name="started" signature="Z"/>
	<fieldref class="java/lang/Thread" name="stopCalled" signature="Z" versions="8-19"/>

	<!-- Field references for Java 19 Virtual Thread. -->
	<fieldref class="java/lang/Thread" name="cont" signature="Ljdk/internal/vm/Continuation;" versions="19-"/>
	<fieldref class="java/lang/Thread" name="holder" signature="Ljava/lang/Thread$FieldHolder;" versions="19-"/>
	<fieldref class="java/lang/Thread$FieldHolder" name="daemon" signature="Z" versions="19-"/>
	<fieldref class="java/lang/Thread$FieldHolder" name="group" signature="Ljava/lang/ThreadGroup;" versions="19-"/>
	<fieldref class="java/lang/Thread$FieldHolder" name="priority" signature="I" versions="19-"/>
	<fieldref class="java/lang/Thread$FieldHolder" name="threadStatus" signature="I" versions="19-"/>

	<!-- Field references for OpenJ9 Java 8-18 Thread. -->
	<fieldref class="java/lang/Thread" name="priority" signature="I" versions="8-18"/>
	<fieldref class="java/lang/Thread" name="isDaemon" signature="Z" versions="8-18"/>
	<fieldref class="java/lang/Thread" name="group" signature="Ljava/lang/ThreadGroup;" versions="8-18"/>

	<fieldref class="java/lang/VirtualThread" name="state" signature="I" versions="19-"/>
	<fieldref class="java/lang/VirtualThread" name="carrierThread" signature="Ljava/lang/Thread;" versions="19-"/>
	<fieldref class="java/lang/VirtualThread" name="cont" signature="Ljdk/internal/vm/Continuation;" versions="19-"/>

	<fieldref class="java/lang/Throwable" name="cause" signature="Ljava/lang/Throwable;"/>
	<fieldref class="java/lang/Throwable" name="detailMessage" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/Throwable" name="walkback" signature="Ljava/lang/Object;"/>
	<fieldref class="java/lang/Throwable" name="stackTrace" signature="[Ljava/lang/StackTraceElement;"/>
	<fieldref class="java/lang/Throwable" name="disableWritableStackTrace" signature="Z"/>
	<fieldref class="java/lang/ExceptionInInitializerError" name="exception" signature="Ljava/lang/Throwable;" versions="8-11"/>
	<fieldref class="java/lang/Boolean" name="value" signature="Z"/>
	<fieldref class="java/lang/Byte" name="value" signature="B"/>
	<fieldref class="java/lang/Character" name="value" signature="C"/>
	<fieldref class="java/lang/Short" name="value" signature="S"/>
	<fieldref class="java/lang/Integer" name="value" signature="I"/>
	<fieldref class="java/lang/Float" name="value" signature="F" cast="U_32"/>
	<fieldref class="java/lang/Long" name="value" signature="J"/>
	<fieldref class="java/lang/Double" name="value" signature="D" cast="U_64"/>
	<fieldref class="java/lang/reflect/Field" name="name" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/reflect/Field" name="type" signature="Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Field" name="signature" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/reflect/Field" name="modifiers" signature="I"/>
	<fieldref class="java/lang/reflect/Field" name="trustedFinal" signature="Z" versions="15-"/>
	<fieldref class="java/lang/reflect/Field" name="annotations" signature="[B"/>
	<fieldref class="java/lang/reflect/Field" name="slot" signature="I"/>
	<fieldref class="java/lang/reflect/Field" name="clazz" signature="Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Method" name="name" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/reflect/Method" name="returnType" signature="Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Method" name="parameterTypes" signature="[Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Method" name="exceptionTypes" signature="[Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Method" name="signature" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/reflect/Method" name="modifiers" signature="I"/>
	<fieldref class="java/lang/reflect/Method" name="annotations" signature="[B"/>
	<fieldref class="java/lang/reflect/Method" name="parameterAnnotations" signature="[B"/>
	<fieldref class="java/lang/reflect/Method" name="annotationDefault" signature="[B"/>
	<fieldref class="java/lang/reflect/Method" name="slot" signature="I"/>
	<fieldref class="java/lang/reflect/Method" name="clazz" signature="Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Constructor" name="parameterTypes" signature="[Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Constructor" name="exceptionTypes" signature="[Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/Constructor" name="signature" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/reflect/Constructor" name="modifiers" signature="I"/>
	<fieldref class="java/lang/reflect/Constructor" name="annotations" signature="[B"/>
	<fieldref class="java/lang/reflect/Constructor" name="parameterAnnotations" signature="[B"/>
	<fieldref class="java/lang/reflect/Constructor" name="slot" signature="I"/>
	<fieldref class="java/lang/reflect/Constructor" name="clazz" signature="Ljava/lang/Class;"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="clazz" signature="Ljava/lang/Class;" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="name" signature="Ljava/lang/String;" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="type" signature="Ljava/lang/Class;" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="accessor" signature="Ljava/lang/reflect/Method;" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="signature" signature="Ljava/lang/String;" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="annotations" signature="[B" versions="14-"/>
	<fieldref class="java/lang/reflect/RecordComponent" name="typeAnnotations" signature="[B" versions="14-"/>
	<fieldref class="java/lang/ThreadGroup" name="name" signature="Ljava/lang/String;"/>
	<fieldref class="java/lang/ThreadGroup" name="maxPriority" signature="I"/>
	<fieldref class="java/lang/ThreadGroup" name="parent" signature="Ljava/lang/ThreadGroup;"/>
	<fieldref class="java/lang/ThreadGroup" name="numThreads" signature="I" versions="8-18"/>
	<fieldref class="java/lang/ThreadGroup" name="numGroups" signature="I" versions="8-18"/>
	<fieldref class="java/lang/ThreadGroup" name="childrenThreads" signature="[Ljava/lang/Thread;" versions="8-18"/>
	<fieldref class="java/lang/ThreadGroup" name="childrenGroups" signature="[Ljava/lang/ThreadGroup;" versions="8-18"/>
	<fieldref class="java/lang/ThreadGroup" name="ngroups" signature="I" versions="19-"/>
	<fieldref class="java/lang/ThreadGroup" name="groups" signature="[Ljava/lang/ThreadGroup;" versions="19-"/>
	<fieldref class="java/lang/ThreadGroup" name="nweaks" signature="I" versions="19-"/>
	<fieldref class="java/lang/ThreadGroup" name="weaks" signature="[Ljava/lang/ref/WeakReference;" versions="19-"/>
	<fieldref class="java/lang/ThreadGroup" name="isDaemon" signature="Z" versions="8-18">
		<fieldalias name="daemon" signature="Z" versions="19-"/>
	</fieldref>
	<fieldref class="java/lang/ThreadGroup" name="childrenGroupsLock" signature="Ljava/lang/Object;" versions="8-18"/>
	<fieldref class="java/lang/ThreadGroup" name="childrenThreadsLock" signature="Ljava/lang/Object;" versions="8-18"/>
	<fieldref class="java/lang/ref/Reference" name="referent" signature="Ljava/lang/Object;"/>
	<fieldref class="java/lang/ref/Reference" name="queue" signature="Ljava/lang/ref/ReferenceQueue;"/>
	<fieldref class="java/lang/ref/Reference" name="state" signature="I"/>
	<fieldref class="java/lang/ref/SoftReference" name="age" signature="I"/>
	<fieldref class="java/util/concurrent/locks/AbstractOwnableSynchronizer" name="exclusiveOwnerThread" signature="Ljava/lang/Thread;"/>
	<fieldref class="java/lang/invoke/PrimitiveHandle" name="vmSlot" signature="J" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PrimitiveHandle" name="referenceClass" signature="Ljava/lang/Class;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PrimitiveHandle" name="rawModifiers" signature="I" cast="U_32" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PrimitiveHandle" name="defc" signature="Ljava/lang/Class;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="kind" signature="B" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="previousAsType" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/NativeMethodHandle" name="J9NativeCalloutDataRef" signature="J" cast="J9NativeCalloutData *" flags="opt_panama"/>
	<fieldref class="java/lang/invoke/ReceiverBoundHandle" name="receiver" signature="Ljava/lang/Object;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConvertHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FoldHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FoldHandle" name="combiner" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FilterArgumentsHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FilterArgumentsHandle" name="startPos" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FilterArgumentsHandle" name="filters" signature="[Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/GuardWithTestHandle" name="guard" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/GuardWithTestHandle" name="trueTarget" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/GuardWithTestHandle" name="falseTarget" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/CollectHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/CollectHandle" name="collectArraySize" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/CollectHandle" name="collectPosition" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConvertHandle" name="requiresBoxing" signature="Z" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/SpreadHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/SpreadHandle" name="arrayClass" signature="Ljava/lang/Class;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/SpreadHandle" name="spreadCount" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/SpreadHandle" name="spreadPosition" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodType" name="argSlots" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodType" name="stackDescriptionBits" signature="[I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/DynamicInvokerHandle" name="site" signature="Ljava/lang/invoke/CallSite;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FilterReturnHandle" name="filter" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VarargsCollectorHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/InvokeExactHandle" name="nextType" signature="Ljava/lang/invoke/MethodType;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VolatileCallSite" name="target" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MutableCallSite" name="target" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PassThroughHandle" name="equivalent" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ThunkTuple" name="i2jInvokeExactThunk" signature="J" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ThunkTuple" name="invocationCount" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="thunks" signature="Ljava/lang/invoke/ThunkTuple;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="invocationCount" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/InsertHandle" name="insertionIndex" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/InsertHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/InsertHandle" name="values" signature="[Ljava/lang/Object;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PermuteHandle" name="next" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/PermuteHandle" name="permute" signature="[I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConstantObjectHandle" name="value" signature="Ljava/lang/Object;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConstantIntHandle" name="value" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConstantFloatHandle" name="value" signature="F" cast="U_32" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConstantLongHandle" name="value" signature="J" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/ConstantDoubleHandle" name="value" signature="D" cast="U_64" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/InvokeGenericHandle" name="castType" signature="Ljava/lang/invoke/MethodType;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VarHandle" name="handleTable" signature="[Ljava/lang/invoke/MethodHandle;" versions="9-" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VarHandle" name="modifiers" signature="I" versions="9-" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FoldHandle" name="foldPosition" signature="I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FoldHandle" name="argumentIndices" signature="[I" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/MethodHandleCache" name="directHandlesHead" signature="Lcom/ibm/oti/util/WeakReferenceNode;" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VarHandleInvokeHandle" name="operation" signature="I" versions="9-" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/VarHandleInvokeHandle" name="accessModeType" signature="Ljava/lang/invoke/MethodType;" versions="9-" flags="opt_methodHandle"/>
	<fieldref class="java/lang/invoke/FieldVarHandle" name="definingClass" signature="Ljava/lang/Class;" versions="9-" flags="opt_methodHandle"/>

	<fieldref class="java/lang/Module" name="loader" signature="Ljava/lang/ClassLoader;" flags="opt_module" versions="9-"/>
	<fieldref class="java/lang/Module" name="name" signature="Ljava/lang/String;" flags="opt_module" versions="9-"/>

	<fieldref class="java/lang/InternalConstantPool" name="vmRef" signature="J" cast="struct J9ConstantPool *"/>

	<fieldref class="com/ibm/oti/util/WeakReferenceNode" name="next" signature="Lcom/ibm/oti/util/WeakReferenceNode;" flags="opt_methodHandle"/>

	<!-- Common field references shared between OpenJ9 and OpenJDK MethodHandles. -->
	<fieldref class="java/lang/invoke/MethodType" name="methodDescriptor" signature="Ljava/lang/String;" flags="opt_methodHandleCommon"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="type" signature="Ljava/lang/invoke/MethodType;" flags="opt_methodHandleCommon"/>
	<fieldref class="java/lang/invoke/MethodType" name="ptypes" signature="[Ljava/lang/Class;" flags="opt_methodHandleCommon"/>
	<fieldref class="java/lang/invoke/MethodType" name="rtype" signature="Ljava/lang/Class;" flags="opt_methodHandleCommon"/>

	<!-- Field references needed to support OpenJDK MethodHandles. -->
	<fieldref class="java/lang/invoke/MemberName" name="clazz" signature="Ljava/lang/Class;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MemberName" name="name" signature="Ljava/lang/String;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MemberName" name="type" signature="Ljava/lang/Object;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MemberName" name="flags" signature="I" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MemberName" name="resolution" signature="Ljava/lang/Object;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/LambdaForm" name="vmentry" signature="Ljava/lang/invoke/MemberName;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MethodHandle" name="form" signature="Ljava/lang/invoke/LambdaForm;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MethodType" name="form" signature="Ljava/lang/invoke/MethodTypeForm;" flags="opt_openjdkMethodhandle"/>
	<fieldref class="java/lang/invoke/MethodTypeForm" name="argCounts" signature="J" flags="opt_openjdkMethodhandle" versions="8-13"/>
	<fieldref class="java/lang/invoke/MethodTypeForm" name="parameterSlotCount" signature="S" flags="opt_openjdkMethodhandle" versions="14-"/>

	<fieldref class="jdk/internal/loader/NativeLibraries$NativeLibraryImpl" name="fromClass" signature="Ljava/lang/Class;" versions="15-"/>

	<fieldref class="jdk/internal/vm/Continuation" name="vmRef" signature="J" cast="struct J9VMContinuation *" versions="19-"/>
	<fieldref class="jdk/internal/vm/Continuation" name="finished" signature="Z" versions="19-"/>
	<fieldref class="jdk/internal/vm/Continuation" name="started" signature="Z" versions="19-"/>
	<fieldref class="jdk/internal/vm/Continuation" name="parent" signature="Ljdk/internal/vm/Continuation;" versions="19-"/>

	<!-- Field references needed to support Foreign Linker API. -->
	<fieldref class="openj9/internal/foreign/abi/InternalDowncallHandler" name="cifNativeThunkAddr" signature="J" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="openj9/internal/foreign/abi/InternalDowncallHandler" name="argTypesAddr" signature="J" flags="opt_openjdkFfi" versions="16-"/>

	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="calleeMH" signature="Ljava/lang/invoke/MethodHandle;" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="calleeType" signature="Ljava/lang/invoke/MethodType;" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="invokeCache" signature="[Ljava/lang/Object;" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="nativeArgArray" signature="[Ljava/lang/Object;" flags="opt_openjdkFfi" versions="16-"/>

	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="scope" signature="Ljdk/incubator/foreign/ResourceScope;" flags="opt_openjdkFfi" versions="16-18"/>
	<fieldref class="openj9/internal/foreign/abi/UpcallMHMetaData" name="session" signature="Ljava/lang/foreign/MemorySession;" flags="opt_openjdkFfi" versions="19-"/>

	<fieldref class="jdk/internal/foreign/MemoryAddressImpl" name="segment" signature="Ljdk/internal/foreign/AbstractMemorySegmentImpl;" flags="opt_openjdkFfi" versions="16-17"/>
	<fieldref class="jdk/internal/foreign/MemoryAddressImpl" name="offset" signature="J" flags="opt_openjdkFfi" versions="16-"/>

	<fieldref class="jdk/internal/foreign/NativeMemorySegmentImpl" name="min" signature="J" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="jdk/internal/foreign/NativeMemorySegmentImpl" name="length" signature="J" flags="opt_openjdkFfi" versions="16-"/>
	<fieldref class="jdk/internal/foreign/NativeMemorySegmentImpl" name="scope" signature="Ljdk/internal/foreign/ResourceScopeImpl;" flags="opt_openjdkFfi" versions="16-18"/>
	<fieldref class="jdk/internal/foreign/NativeMemorySegmentImpl" name="session" signature="Ljava/lang/foreign/MemorySession;" flags="opt_openjdkFfi" versions="19-"/>

<!--
	NOTE: the resolution code in jclcinit.c only looks at the J9ROMClassRef->runtimeFlags to determine
	whether or not to attempt the class load.  The flags specified on the methods are ignored.
	The method flags are only documentation to help map which feature (as expressed on the class) requires
	the particular method.

	This is a limitation of the tool as it would otherwise need to encode the class multiple times - once
	for each combination of method flags.
-->
	<staticmethodref class="java/lang/J9VMInternals" name="completeInitialization" signature="()V"/>
	<staticmethodref class="java/lang/J9VMInternals" name="checkPackageAccess" signature="(Ljava/lang/Class;Ljava/security/ProtectionDomain;)V"/>
	<staticmethodref class="java/lang/J9VMInternals" name="threadCleanup" signature="(Ljava/lang/Thread;)V"/>
	<staticmethodref class="java/lang/J9VMInternals" name="newInstanceImpl" signature="(Ljava/lang/Class;)Ljava/lang/Object;" flags="jit_newInstancePrototype"/>
	<staticmethodref class="java/lang/J9VMInternals" name="formatNoSuchMethod" signature="(Ljava/lang/String;Ljava/lang/Class;Ljava/lang/String;Ljava/lang/Class;Ljava/lang/String;)Ljava/lang/String;"/>
	<specialmethodref class="java/lang/invoke/MethodHandle" name="forGenericInvoke" signature="(Ljava/lang/invoke/MethodType;Z)Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<specialmethodref class="java/lang/invoke/MethodHandle" name="returnFilterPlaceHolder" signature="()Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<specialmethodref class="java/lang/invoke/MethodHandle" name="foldHandlePlaceHolder" signature="()Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<specialmethodref class="java/lang/invoke/MethodHandle" name="guardWithTestPlaceHolder" signature="()Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<specialmethodref class="java/lang/invoke/MethodHandle" name="filterArgumentsPlaceHolder" signature="(III)Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandle"/>
	<virtualmethodref class="java/lang/ClassLoader" name="loadClass" signature="(Ljava/lang/String;)Ljava/lang/Class;"/>
	<specialmethodref class="java/lang/Thread" name="uncaughtException" signature="(Ljava/lang/Throwable;)V"/>
	<specialmethodref class="java/lang/Thread" name="&lt;init>" signature="(Ljava/lang/String;Ljava/lang/Object;IZ)V"/>
	<staticmethodref class="java/lang/ClassLoader" name="findNative" signature="(Ljava/lang/ClassLoader;Ljava/lang/String;)J" versions="17-"/>

	<fieldref class="java/lang/J9VMInternals$ClassInitializationLock" name="theClass" signature="Ljava/lang/Class;"/>

	<!-- Class initialization in C -->
	<staticmethodref class="java/lang/J9VMInternals" name="initializationAlreadyFailed" signature="(Ljava/lang/Class;)V"/>
	<staticmethodref class="java/lang/J9VMInternals" name="recordInitializationFailure" signature="(Ljava/lang/Class;Ljava/lang/Throwable;)V"/>

	<!-- Static method references needed to support OpenJ9 and OpenJDK MethodHandles. -->
	<staticmethodref class="java/lang/invoke/MethodTypeHelper" name="vmResolveFromMethodDescriptorString" signature="(Ljava/lang/String;Ljava/lang/ClassLoader;Ljava/lang/Class;)Ljava/lang/invoke/MethodType;" flags="opt_methodHandleCommon"/>
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="sendResolveMethodHandle" signature="(ILjava/lang/Class;Ljava/lang/Class;Ljava/lang/String;Ljava/lang/String;Ljava/lang/ClassLoader;)Ljava/lang/invoke/MethodHandle;" flags="opt_methodHandleCommon"/>
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="resolveInvokeDynamic" signature="(JLjava/lang/String;Ljava/lang/String;J)Ljava/lang/Object;" flags="opt_methodHandleCommon"/>
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="resolveConstantDynamic" signature="(JLjava/lang/String;Ljava/lang/String;J)Ljava/lang/Object;" versions="11-" flag="opt_methodHandleCommon"/>
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="constructorPlaceHolder" signature="(Ljava/lang/Object;)Ljava/lang/Object;" flags="opt_methodHandleCommon"/>

	<!-- Static method references needed to support OpenJDK MethodHandles. -->
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="linkCallerMethod" signature="(Ljava/lang/Class;ILjava/lang/Class;Ljava/lang/String;Ljava/lang/String;)Ljava/lang/Object;" flags="opt_openjdkMethodhandle"/>

	<!-- Static method references needed to support Foreign Linker API. -->
	<staticmethodref class="java/lang/invoke/MethodHandleResolver" name="upcallLinkCallerMethod" signature="(Ljava/lang/Class;Ljava/lang/invoke/MethodType;)Ljava/lang/Object;" versions="16-"/>

	<staticmethodref class="jdk/internal/loader/NativeLibraries" name="load" signature="(Ljdk/internal/loader/NativeLibraries$NativeLibraryImpl;Ljava/lang/String;ZZZ)Z" versions="15-18"/>
	<staticmethodref class="jdk/internal/loader/NativeLibraries" name="load" signature="(Ljdk/internal/loader/NativeLibraries$NativeLibraryImpl;Ljava/lang/String;ZZ)Z" versions="19-"/>

	<!-- Static method references needed to support VirtualThread/Continuation. -->
	<staticmethodref class="jdk/internal/vm/Continuation" name="execute" signature="(Ljdk/internal/vm/Continuation;)V" versions="19-"/>
	<!-- Security manager check -->
	<staticfieldref class="java/lang/System" name="security" signature="Ljava/lang/SecurityManager;"/>

	<!-- VM constants in java -->
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_NONE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_ALWAYS" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_OLDCHECK" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_CARDMARK" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_CARDMARK_INCREMENTAL" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_CARDMARK_AND_OLDCHECK" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_SATB" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_WRITE_BARRIER_TYPE_SATB_AND_OLDCHECK" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_ALLOCATION_TYPE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_ALLOCATION_TYPE_TLH" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_ALLOCATION_TYPE_SEGREGATED" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_OPTTHRUPUT" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_OPTAVGPAUSE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_GENCON" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_BALANCED" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_METRONOME" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_GC_POLICY_NOGC" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_JAVA_CLASS_RAM_SHAPE_SHIFT" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="OBJECT_HEADER_SHAPE_MASK" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_INSTANCESIZE_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_INSTANCE_DESCRIPTION_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_LOCK_OFFSET_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_LOCK_RESERVATION_HISTORY_RESERVED_COUNTER_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_LOCK_RESERVATION_HISTORY_CANCEL_COUNTER_OFFSET" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_INITIALIZE_STATUS_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="OBJECT_HEADER_SIZE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="ADDRESS_SIZE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_SIZE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="FJ9OBJECT_SIZE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_CLASS_DEPTH_AND_FLAGS_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_INIT_SUCCEEDED" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_SUPERCLASSES_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_ROMCLASS_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9ROMCLASS_MODIFIERS_OFFSET" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_JAVA_CLASS_DEPTH_MASK" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_JAVA_CLASS_MASK" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_ACC_CLASS_INTERNAL_PRIMITIVE_TYPE" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_ACC_CLASS_ARRAY" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_JIT_STRING_DEDUP_POLICY" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_STRING_COMPRESSION_ENABLED" signature="Z"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="OBJECT_HEADER_HAS_BEEN_MOVED_IN_CLASS" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="IS_BIG_ENDIAN" signature="Z"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_CLASSLOADER_TYPE_OTHERS" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_CLASSLOADER_TYPE_BOOT" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="J9_CLASSLOADER_TYPE_PLATFORM" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="J9CLASS_RESERVABLE_LOCK_WORD_INIT" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="OBJECT_HEADER_LOCK_RESERVED" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="OBJECT_HEADER_LOCK_LEARNING" signature="I"/>

	<staticfieldref class="com/ibm/oti/vm/VM" name="GLR_ENABLE_GLOBAL_LOCK_RESERVATION" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="GLR_RESERVED_ABSOLUTE_THRESHOLD" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="GLR_MINIMUM_RESERVED_RATIO" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="GLR_CANCEL_ABSOLUTE_THRESHOLD" signature="I"/>
	<staticfieldref class="com/ibm/oti/vm/VM" name="GLR_MINIMUM_LEARNING_RATIO" signature="I"/>
</vmconstantpool>
